# -*- coding: utf-8 -*-
#Библиотеки, които използват python и Kodi в тази приставка
import re
import sys
import os
import urllib
import urllib2
import xbmc
import xbmcgui
import xbmcplugin
import xbmcaddon
import json

#Място за дефиниране на константи, които ще се използват няколкократно из отделните модули
__addon_id__= 'plugin.video.tubi'
__Addon = xbmcaddon.Addon(__addon_id__)
searchicon = xbmc.translatePath(__Addon.getAddonInfo('path') + "/resources/search.png")

MUA = 'Mozilla/5.0 (Linux; Android 5.0.2; bg-bg; SAMSUNG GT-I9195 Build/JDQ39) AppleWebKit/535.19 (KHTML, like Gecko) Version/1.0 Chrome/18.0.1025.308 Mobile Safari/535.19' #За симулиране на заявка от мобилно устройство
UA = 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:50.0) Gecko/20100101 Firefox/50.0' #За симулиране на заявка от  компютърен браузър


#Категории на съдържанието
def CATEGORIES():
        addDir('Search','https://tubitv.com/oz/search/',2,searchicon)
        addDir('Featured','1611',1,'DefaultFolder.png')
        addDir('New Arrivals','1643',1,'DefaultFolder.png')
        addDir('Not on Netflix','1851',1,'DefaultFolder.png')
        addDir('TV Dramas','500007',1,'DefaultFolder.png')
        addDir('Dramatic Movies','1291',1,'DefaultFolder.png')
        addDir('Comedy Movies','1290',1,'DefaultFolder.png')
        addDir('Action and Suspense','1613',1,'DefaultFolder.png')
        addDir('Movie Night!','500026',1,'DefaultFolder.png')
        addDir('Black Cinema','500034',1,'DefaultFolder.png')
        addDir('Anime','500028',1,'DefaultFolder.png')
        addDir('Fright Night','1324',1,'DefaultFolder.png')
        addDir('Reality','1333',1,'DefaultFolder.png')
        addDir('Extreme Adventures','500015',1,'DefaultFolder.png')
        addDir('TV Comedies','500006',1,'DefaultFolder.png')
        addDir('Stand Up Comedy','500025',1,'DefaultFolder.png')
        addDir('Kids and Family','1432',1,'DefaultFolder.png')
        addDir('Romance','1293',1,'DefaultFolder.png')
        addDir('Spirituality','500020',1,'DefaultFolder.png')
        addDir('Crime TV','500013',1,'DefaultFolder.png')
        addDir('Highly Rated on Rotten Tomatoes','1951',1,'DefaultFolder.png')
        addDir('Documentaries','1295',1,'DefaultFolder.png')
        addDir('Out of this World','500009',1,'DefaultFolder.png')
        addDir('Foreign Favorites','1538',1,'DefaultFolder.png')
        addDir('Cult Favorites','500008',1,'DefaultFolder.png')
        addDir('Todo en Español','500022',1,'DefaultFolder.png')
        addDir('Chinese TV','500037',1,'DefaultFolder.png')
        addDir('Good Eats','500016',1,'DefaultFolder.png')
        addDir('Film Festival Favorites','1612',1,'DefaultFolder.png')
        addDir('Wild Things (Nature)','500018',1,'DefaultFolder.png')
        addDir('Grindhouse','500001',1,'DefaultFolder.png')
        addDir('Killer Kung Fu','500002',1,'DefaultFolder.png')
        addDir('Get Fit!','1562',1,'DefaultFolder.png')
        addDir('Musicals and Live Performance','500021',1,'DefaultFolder.png')
        addDir('Fan Favorites','500011',1,'DefaultFolder.png')
        #addDir('','',1,'DefaultFolder.png')
        #addDir('','',1,'')




#Разлистване заглавията от отделните категории
def INDEXCONTENT(url):
        req = urllib2.Request('https://tubitv.com/oz/categories/'+url+'/content')
        req.add_header('User-Agent', UA)
        req.add_header('Referer', 'https://tubitv.com/')
        opener = urllib2.build_opener()
        f = opener.open(req)
        jsonrsp = json.loads(f.read())
        #print jsonrsp[0]['n']
        #print jsonrsp[0]['i']
        #print jsonrsp[0]['t']
        #print str(jsonrsp[0]['s'])
        #print jsonrsp[0]['pp']
        
        #Начало на обхождането
        for movie in range(0, len(jsonrsp)):
            try:
                if jsonrsp[movie]['t'] == 'v': #Ако е игрален филм
                    addLink(jsonrsp[movie]['n'],jsonrsp[movie]['i'],str(jsonrsp[movie]['s']),3,'http:'+jsonrsp[movie]['pp'])
                elif jsonrsp[movie]['t'] == 's': #Ако е сериал
                    addDir(jsonrsp[movie]['n'],jsonrsp[movie]['i'],4,'http:'+jsonrsp[movie]['pp'])
            except:
                pass
        #Край на обхождането
        
        
        
#Разлистване заглавията от търсенето
def SEARCHCONTENT(url):
        req = urllib2.Request(url)
        req.add_header('User-Agent', UA)
        req.add_header('Referer', 'https://tubitv.com/')
        opener = urllib2.build_opener()
        f = opener.open(req)
        jsonrsp = json.loads(f.read())
        
        #Начало на обхождането
        for movie in range(0, len(jsonrsp)):
            try:
                if jsonrsp[movie]['t'] == 'v': #Ако е игрален филм
                    addLink(jsonrsp[movie]['n'],jsonrsp[movie]['i'],str(jsonrsp[movie]['s']),3,'http:'+jsonrsp[movie]['pp'])
                elif jsonrsp[movie]['t'] == 's': #Ако е сериал
                    addDir(jsonrsp[movie]['n'],jsonrsp[movie]['i'],4,'http:'+jsonrsp[movie]['pp'])
            except:
                pass
        #Край на обхождането





#Разлистване епизодите на сериал
def EPISODES(url):
        req = urllib2.Request('https://tubitv.com/oz/videos/0'+url+'/content')
        req.add_header('User-Agent', UA)
        req.add_header('Referer', 'https://tubitv.com/')
        opener = urllib2.build_opener()
        f = opener.open(req)
        jsonrsp = json.loads(f.read())
        #print jsonrsp['k'][0]
        
        #Начало на обхождането
        for season in range(0, len(jsonrsp['k'])):
            for episode in range(0, len(jsonrsp['k'][season]['k'])):
                addLink(jsonrsp['k'][season]['k'][episode]['n'],jsonrsp['k'][season]['k'][episode]['i'],str(jsonrsp['k'][season]['k'][episode]['s']),3,'http:'+jsonrsp['k'][season]['k'][episode]['pt'])
        #Край на обхождането





#Търсачка
def SEARCH(url):
        keyb = xbmc.Keyboard('', 'Search in TUBI Database')
        keyb.doModal()
        searchText = ''
        if (keyb.isConfirmed()):
            searchText = urllib.quote_plus(keyb.getText())
            searchText=searchText.replace(' ','+')
            searchurl = url + searchText
            searchurl = searchurl.encode('utf-8')
            SEARCHCONTENT(searchurl)
        else:
            addDir('Go to main menu...','','',"DefaultFolderBack.png")







#Зареждане на видео
def PLAY(name,url,iconimage):
        req = urllib2.Request('https://tubitv.com/oz/videos/'+url+'/content')
        req.add_header('User-Agent', UA)
        req.add_header('Referer', 'https://tubitv.com/')
        opener = urllib2.build_opener()
        f = opener.open(req)
        jsonrsp = json.loads(f.read())
        #print jsonrsp['mh']
        
        li = xbmcgui.ListItem(iconImage=iconimage, thumbnailImage=iconimage, path='http:'+jsonrsp['mh']+'|User-Agent=stagefright&X-Forwarded-For=52.9.185.254')
        li.setInfo('video', { 'title': name })
        try:
            xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, xbmcgui.ListItem(path = 'http:'+jsonrsp['mh']+'|User-Agent=stagefright&X-Forwarded-For=52.9.185.254'))
        except:
            xbmc.executebuiltin("Notification('Грешка','Видеото липсва на сървъра!')")






#Модул за добавяне на отделно заглавие и неговите атрибути към съдържанието на показваната в Kodi директория - НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def addLink(name,url,vd,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        liz.addStreamInfo('video', { 'codec': 'h264', 'width': 1280, 'height': 720, 'duration': vd })
        liz.setProperty("IsPlayable" , "true")
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        return ok

#Модул за добавяне на отделна директория и нейните атрибути към съдържанието на показваната в Kodi директория - НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def addDir(name,url,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok


#НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param



params=get_params()
url=None
name=None
iconimage=None
mode=None

try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        name=urllib.unquote_plus(params["iconimage"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass


#Списък на отделните подпрограми/модули в тази приставка - трябва напълно да отговаря на кода отгоре
if mode==None or url==None or len(url)<1:
        CATEGORIES()
    
elif mode==1:
        INDEXCONTENT(url)

elif mode==2:
        SEARCH(url)

elif mode==3:
        PLAY(name,url,iconimage)

elif mode==4:
        EPISODES(url)

elif mode==5:
        SEARCHCONTENT(url)


xbmcplugin.endOfDirectory(int(sys.argv[1]))
